
*SHARETOM.ADO
*version 1.0
*2009/29/06


 capture program drop sharetom
 program define sharetom, rclass
 syntax varlist [, replace]


*get rid of globals:

 capture macro drop n

 qui ds
 global n `r(varlist)'


*error codes if replace is wrongly specified

 if "`replace'"=="replace" & "`varlist'"!="$n" {
  di as error "replace requires _all in varlist;"
  di as error "no action taken"
  exit
 }


*procedure if replace option correctly specified:

 if "`replace'"=="replace" & "`varlist'"=="$n" {

 preserve

 uselabel, var clear

 qui sum value
 if r(min)>=0 {
  di as error "no labels containing valid missing codes found;"
  di as error "no action taken"
  exit 9
 }

 qui {
  keep lname value
  drop if value>=0
  drop if value<=-9999991
 }

 if _N>1 {
  by lname, sort: gen j=_n
  qui reshape wide value, i(lname) j(j)
  foreach i in 1 2 3 4 5 6 7 8 {
   capture tostring value`i', replace
  }
 }
 if _N==1 {
  capture tostring value, gen(value1)
 }

 if _N>0 {

 capture gen _miss=value1
 capture replace _miss="" if _miss=="."
  foreach i in 2 3 4 5 6 7 8 {
   capture replace value`i'="" if value`i'=="."
   capture replace _miss=_miss+" "+value`i' 
  }

 foreach i of numlist 1/8 {
  capture drop value`i'
 }

 global Nlab=_N+1
 local N=_N+1
 local i=1
 while `i'<`N' {
  qui gen l_n`i'=lname[`i'] 
  local i=`i'+1
 }

 foreach var of varlist l_n* {
  capture macro drop `var'
  global `var'=`var'
 }

 keep lname _miss

 local N=_N+1
 local i=1
 while `i'<`N' {
  qui gen l_m`i'=_miss[`i'] 
  local i=`i'+1
 }

 foreach var of varlist l_m* {
  capture macro drop `var'
  global `var'=`var'
 }
 
 }

 restore

 local i=1
 while `i'<$Nlab {
  qui lab li ${l_n`i'}
  if `r(min)'>=-9 & `r(min)'<=-1 {
   if strpos("${l_m`i'}","-1") !=0 {
    lab de ${l_n`i'} .a "don't know" -1 "", modify
   }
    if strpos("${l_m`i'}","-2") !=0 {
     lab de ${l_n`i'} .b "refusal" -2 "", modify
    }
    if strpos("${l_m`i'}","-3") !=0 {
     lab de ${l_n`i'} .c "implausible/suspected wrong" -3 "", modify
    }
    if strpos("${l_m`i'}","-4") !=0 {
     lab de ${l_n`i'} .d "not codable" -4 "", modify
    }
    if strpos("${l_m`i'}","-5") !=0 {
     lab de ${l_n`i'} .e "not answered" -5 "", modify
    }
    if strpos("${l_m`i'}","-6") !=0 {
     lab de ${l_n`i'} .f "proxy missing" -6 "", modify
    }
    if strpos("${l_m`i'}","-7") !=0 {
     lab de ${l_n`i'} .g "not yet coded (temporary)" -7 "", modify
    }
    if strpos("${l_m`i'}","-9") !=0 {
     lab de ${l_n`i'} .i "not applicable (e.g.filtered)" -9 "", modify
    }
   }
  local i=`i'+1
  }

  qui label dir
  foreach lab in `r(names)' {
   qui lab list `lab'
   if `r(min)'==-9999992|`r(min)'==-9999991 {
    lab def `lab' .a "don't know" .b "refusal" -9999992 "" -9999991 "", modify
   }
  }

  local i=1
  while `i'<$Nlab {
   macro drop l_n`i' l_m`i'
   local i=`i'+1
  }
  
 macro drop Nlab

 }


*missing recode:

 qui ds `varlist', has(vall)
 return local varlist `r(varlist)'
 foreach var of varlist `r(varlist)' {
  capture confirm numeric variable `var'  
   if !_rc {                               
    qui {
     sum `var'
     scalar min=r(min)
     mvdecode `var' if min>=-9 & min<=-1, mv(-1=.a\-2=.b\-3=.c\-4=.d\-5=.e\-6=.f\-7=.g\-9=.i)
     mvdecode `var' if min==-9999992|min==-9999991, mv(-9999992=.b\-9999991=.a)
     scalar drop min
    }
   }
  }

 macro drop n


 end




